%MEX-file for MATLAB 5.x
% 
%Implements the Z step of the zpim algoritm 
%      (see ieeetip, vol 11, no. 4, pp. 408-422, 2002)
%
%Mallab call:
%unwph = zs(wph,disc);
%
%--------------Input parameters -------------------
%wph	-> wrapped phase matrix (DATATYPE - single)
%disc -> discontinuity matrix (DATATYPE - single)
%
%--------------Output  parameters -----------------
%unwph	-> unwrapped phase matrix (DATATYPE - single)
%
%===================================================
% NOTE1:
%
%The discontinuity matrix is given by
%
%	disc = 1000*(1-dh)+1000*1001*(1-dv);
%
%where
%
%dv  - is the vertical discontinuity matrix. 
%dv(i,j) = 1 represents a vertical discontinuity 
%between site (i,j-1) and site (i,j); dv(i,j) \in [0,1]
%
%dh  - is the horizontal discontinuity matrix. 
%dh(i,j) = 1 represents a horizontal discontinuity 
%between site (i-1,j) and site (i,j); dh \in [0 1]
%
%The function disc = single(dbuild(dh,dv)) is supplied to
%buid matrix disc.
%
%To recover dh and dv (scaled by 1000) apply
%
%  dh = rem(disc,1001); 
%  dv = floor(disc/1001);
%
%Variables dh and dv can take any value in [0,1]. In this way,
%they can be used not only to signal discontinuities, but also
%as horizontal and vertical quality maps. Note that usually qual=1
%means a high quality , whereas dv,dh=0 means the opposite. Therefore,
%if qualh and qualv represent horizontal and vertical quality information, 
%then matrix disc shal be built as
%  
%  disc = single(dbuild(1-qualh,1-qualv)).
%
% 
% NOTE2:
% 
% Functions  unwph=zstep(wph), unwph=zstepd(wph,dh,dv), and
% unwph=zstepq(wph,qh,qv) are conventional MATLAB functions wrapping 
%the MEX file zs().
%
%  
%
%Author: Jose M Bioucas Dias, June, 2003 



